/* main.c -- (c) chris kern -- Mon Feb 16 20:35:41 EST 2009     */
/* "Don't fear the pen. When in doubt, draw a pretty picture."  */
/*     -- Baker's Third Law of Design.                           */

#include <stdint.h>
#include "lcd.h"
#include <avr/io.h>
#include <util/delay.h>

typedef struct Point {
	int x;
	int y;
} Point;

Point adrese_m[9][9];
int sudoku[9][9] = {  {-1, -1,  2, -1, -1, -1,  6, -1,  1},
					  {-1,  8,  9, -1,  2, -1, -1, -1,  3},
					  {-1, -1, -1, -1,  9, -1, -1, -1,  5},
					  {-1, -1,  4, -1, -1,  2, -1, -1, -1}, 
					  {-1,  9, -1,  5, -1,  3, -1,  8, -1},
					  {-1, -1, -1,  6, -1, -1,  1, -1, -1},
					  { 9, -1, -1, -1,  7, -1, -1, -1, -1},
					  { 1, -1, -1, -1,  6, -1,  9,  4, -1},
					  { 4, -1,  7, -1, -1, -1,  5, -1, -1}};
					  
				
int solved[9][9] = { {3,4,2,8,5,7,6,9,1},
					  {5,8,9,1,2,6,4,7,3},
					  {7,1,6,3,9,4,8,2,5},
					  {8,5,4,7,1,2,3,6,9},
					  {6,9,1,5,4,3,7,8,2},
					  {2,7,3,6,8,9,1,5,4},
					  {9,6,5,4,7,1,2,3,8},
					  {1,3,8,2,6,5,9,4,7},
					  {4,2,7,9,3,8,5,1,6}};





void print_initial(){
	int i,j;
	for ( i = 0 ; i < 9; i++ ) {
		for ( j = 0; j < 9; j++ ){
			if ( sudoku[i][j] != -1 ){
				print_number( adrese_m[i][j].x + 2 ,adrese_m[i][j].y -1, sudoku[i][j]);
				
			}
		}
	}
	print_number(adrese_m[0][0].x + 2 ,adrese_m[0][0].y -1, 0);
	
}



void init_m_adress ( ) {
	int i, j;
	for ( j = 0 ; j < 9; j++ ) {
	
		
		for ( i = 0; i < 9; i++ ){
			adrese_m[j][i].x = 2 + i * 13;
			adrese_m[j][i].y = 2 + j* 7;
		}
	
	}
}


void init_buttons(void) {

    DDRC = 0xff;
    PORTC = 0x00;

    // LEFT
    DDRC &= ~(1 << PC0);
    PORTC |= (1 << PC0);
    
    // RIGHT
    DDRC &= ~(1 << PC1);
    PORTC |= (1 << PC1);
    
    // UP
    DDRC &= ~(1 << PC2);
    PORTC |= (1 << PC2);
    
    // DOWN
    DDRC &= ~(1 << PC3);
    PORTC |= (1 << PC3);
	
	
	// INCREMENT
	DDRC &= ~(1 << PC4);
    PORTC |= (1 << PC4);
	
    
    // LED user
    DDRD |= (1 << PD7);
}

int left (){
	if ((PINC & (1 << PC0)) == 0 )
		return 1;
	return 0;
}
int right (){
	if ((PINC & (1 << PC1)) == 0 )
		return 1;
	return 0;
}
int up (){
	if ((PINC & (1 << PC2)) == 0 )
		return 1;
	return 0;
}
int down (){
	if ((PINC & (1 << PC3)) == 0 )
		return 1;
	return 0;
}
int increment() {
	if ((PINC & (1 << PC4)) == 0 )
		return 1;
	return 0;
}


void check_solution(uint8_t a, uint8_t b){
	int i = (int)a;
	int j = (int)b;
	
	if ( sudoku[i][j] == solved[i][j] ){
	 PORTD |= (1 << PD7);
	 _delay_ms(2000);
	}
	 
	 PORTD &= ~(1 << PD7);

}


int main(void){
	DDRD = 1<<PD7;
	
  uint8_t x, y, z = 0;
  lcd_init();
  int cx = 0;
  int cy = 0;
  int sem = 0;

  init_m_adress();
  print_shape();
  print_initial();
  init_buttons();
  
  /* Treat input */
  while (1){

  
  
  if ( right() && cx < 8 ) {
	clear_cell(adrese_m[cy][cx].x, adrese_m[cy][cx].y);
	_delay_ms(100);
	if (cx != 8 ){
		cx++;
		clear_cell(adrese_m[cy][cx].x, adrese_m[cy][cx].y);
		clear_cell(adrese_m[cy][cx-1].x, adrese_m[cy][cx-1].y);
		if ( sudoku[cy][cx-1] != -1 )
			print_number(adrese_m[cy][cx-1].x +2, adrese_m[cy][cx-1].y -1,sudoku[cy][cx-1]);
		else
			clear_cell(adrese_m[cy][cx-1].x, adrese_m[cy][cx-1].y);
		print_number(adrese_m[cy][cx].x +2, adrese_m[cy][cx].y -1,0);
		_delay_ms(100);
		sem = 0;
	}
	

  }
  else if ( left() && cx > 0 ) {
	clear_cell(adrese_m[cy][cx].x, adrese_m[cy][cx].y);
	_delay_ms(100);
	if (cx != 0 ){
		cx--;
		clear_cell(adrese_m[cy][cx].x, adrese_m[cy][cx].y);
		clear_cell(adrese_m[cy][cx+1].x, adrese_m[cy][cx+1].y);
		if ( sudoku[cy][cx+1] != -1 )
			print_number(adrese_m[cy][cx+1].x +2, adrese_m[cy][cx+1].y -1,sudoku[cy][cx+1]);
		else
			clear_cell(adrese_m[cy][cx+1].x, adrese_m[cy][cx+1].y);
		print_number(adrese_m[cy][cx].x +2, adrese_m[cy][cx].y -1,0);
		_delay_ms(100);
		sem = 0;
	}

  }
  else if ( down() && cy < 8 ) {
	clear_cell(adrese_m[cy][cx].x, adrese_m[cy][cx].y);
	_delay_ms(100);
	if (cy != 8 ){
		cy++;
		clear_cell(adrese_m[cy][cx].x, adrese_m[cy][cx].y);
		clear_cell(adrese_m[cy-1][cx].x, adrese_m[cy-1][cx].y);
		if ( sudoku[cy-1][cx] != -1 )
			print_number(adrese_m[cy-1][cx].x +2, adrese_m[cy-1][cx].y -1,sudoku[cy-1][cx]);
		else
			clear_cell(adrese_m[cy-1][cx].x, adrese_m[cy-1][cx].y);
		print_number(adrese_m[cy][cx].x +2, adrese_m[cy][cx].y -1,0);
		_delay_ms(100);
		sem = 0;
	}

  }
  else if ( up() && cy > 0 ) {
	clear_cell(adrese_m[cy][cx].x, adrese_m[cy][cx].y);
	_delay_ms(100);
	if (cy != 0 ){
		cy--;
		clear_cell(adrese_m[cy][cx].x, adrese_m[cy][cx].y);
		clear_cell(adrese_m[cy+1][cx].x, adrese_m[cy+1][cx].y);
		if ( sudoku[cy+1][cx] != -1 )
			print_number(adrese_m[cy+1][cx].x +2, adrese_m[cy+1][cx].y -1,sudoku[cy+1][cx]);
		else
			clear_cell(adrese_m[cy+1][cx].x, adrese_m[cy+1][cx].y);
		print_number(adrese_m[cy][cx].x +2, adrese_m[cy][cx].y -1,0);
		_delay_ms(100);
		sem = 0;
	}

  }
  else if ( increment() ) {
	int value = sudoku[cy][cx];
	if ( value == 9 )
		value = 1;
	else if (value != -1 ) value++;
	else value = 1;
	_delay_ms(300);
	clear_cell(adrese_m[cy][cx].x , adrese_m[cy][cx].y );
	_delay_ms(300);
	print_number(adrese_m[cy][cx].x +2, adrese_m[cy][cx].y -1,value);
	_delay_ms(300);
	sudoku[cy][cx] = value;
	check_solution(cy,cx);;
	sem = 0;
  }
  

  }

  return 0;
}
